"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var path_1 = __importDefault(require("path"));
var logger_1 = __importDefault(require("./utils/logger"));
var findExtension_1 = require("./utils/findExtension");
var Builder = /** @class */ (function () {
    function Builder(docker) {
        this.docker = docker;
    }
    Builder.prototype.build = function (langs) {
        return __awaiter(this, void 0, void 0, function () {
            var supportedLanguages, languages, streams, resolvedStreams, e_1, progress, e_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        supportedLanguages = Object.keys(findExtension_1.extension);
                        languages = langs || supportedLanguages;
                        streams = [];
                        languages.forEach(function (lang) {
                            if (supportedLanguages.includes(lang)) {
                                logger_1["default"].info("Building " + lang + "...");
                                streams.push(_this.docker.buildImage({
                                    context: path_1["default"].join(__dirname, 'langs', lang),
                                    src: ['Dockerfile', 'start.sh']
                                }, {
                                    t: lang.toLowerCase() + "-runner"
                                }));
                            }
                            else {
                                streams.push(Promise.reject(new Error(lang + " is not supported")));
                            }
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, Promise.all(streams)];
                    case 2:
                        resolvedStreams = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        logger_1["default"].error(e_1);
                        return [2 /*return*/, Promise.reject(e_1)];
                    case 4:
                        progress = [];
                        (resolvedStreams).forEach(function (stream) {
                            stream.on('data', function (chunk) {
                                logger_1["default"].debug(chunk);
                            });
                            progress.push(new Promise(function (resolve, reject) {
                                _this.docker.modem.followProgress(stream, function (err, res) {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve(res);
                                    }
                                });
                            }));
                        });
                        _a.label = 5;
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, Promise.all(progress)];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        e_2 = _a.sent();
                        logger_1["default"].error(e_2);
                        return [2 /*return*/, Promise.reject(e_2)];
                    case 8:
                        logger_1["default"].info('Built containers successfully');
                        return [2 /*return*/, null];
                }
            });
        });
    };
    return Builder;
}());
exports["default"] = Builder;
