"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var perf_hooks_1 = require("perf_hooks");
var del_1 = __importDefault(require("del"));
var decodeBase64_1 = __importDefault(require("./utils/decodeBase64"));
var logger_1 = __importDefault(require("./utils/logger"));
var getOutput_1 = __importDefault(require("./utils/getOutput"));
var saveCode_1 = __importDefault(require("./utils/saveCode"));
var Runner = /** @class */ (function () {
    function Runner(docker) {
        this.docker = docker;
    }
    Runner.prototype.run = function (_a) {
        var id = _a.id, tag = _a.tag, code = _a.code, testCases = _a.testCases, base64 = _a.base64, folderPath = _a.folderPath, language = _a.language, timeout = _a.timeout, memory = _a.memory, CPUs = _a.CPUs;
        return __awaiter(this, void 0, void 0, function () {
            var Paths, promisesToKeep, i, t0, e_1, t1, _b, output, runTime, error, exitCodes, tests, i, expectedOutput, obtainedOutput, time, exitCode, remarks, result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, saveCode_1["default"](folderPath, code, testCases, base64, language)];
                    case 1:
                        Paths = _c.sent();
                        promisesToKeep = [];
                        for (i = 0; i < Paths.length; i += 1) {
                            promisesToKeep.push(this.docker.run(tag, ['bash', '/start.sh', "" + i, "" + timeout], null, {
                                User: 'runner',
                                HostConfig: {
                                    CpuPeriod: 100000,
                                    CpuQuota: CPUs * 1000000,
                                    Memory: memory * 1000000,
                                    NetworkMode: 'none',
                                    AutoRemove: true,
                                    Mounts: [{
                                            Source: Paths[i],
                                            Target: '/app',
                                            Type: 'bind'
                                        }]
                                }
                            }));
                        }
                        logger_1["default"].info("Starting process " + id);
                        t0 = perf_hooks_1.performance.now();
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, Promise.all(promisesToKeep)];
                    case 3:
                        _c.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _c.sent();
                        return [2 /*return*/, Promise.reject(e_1)];
                    case 5:
                        t1 = perf_hooks_1.performance.now();
                        logger_1["default"].info("Process " + id + " completed in " + (t1 - t0) / 1000 + " seconds");
                        return [4 /*yield*/, getOutput_1["default"](Paths, testCases.length)];
                    case 6:
                        _b = _c.sent(), output = _b[0], runTime = _b[1], error = _b[2], exitCodes = _b[3];
                        Paths.forEach(function (Path) {
                            del_1["default"](Path, {
                                force: true
                            });
                        });
                        tests = [];
                        for (i = 0; i < testCases.length; i += 1) {
                            expectedOutput = (base64)
                                ? decodeBase64_1["default"](testCases[i].output)
                                : testCases[i].output;
                            obtainedOutput = output[i].toString();
                            time = runTime[i].toString().split('\n');
                            exitCode = parseInt(exitCodes[i].toString(), 10);
                            remarks = void 0;
                            if (exitCode === 124) {
                                remarks = 'Time limit exceeded';
                            }
                            else if (exitCode === 0) {
                                remarks = expectedOutput.trim() === obtainedOutput.trim() ? 'Pass' : 'Fail';
                            }
                            else {
                                remarks = 'Error';
                            }
                            tests.push({
                                input: testCases[i].input,
                                expectedOutput: expectedOutput,
                                obtainedOutput: obtainedOutput,
                                remarks: remarks,
                                exitCode: exitCode,
                                error: error[i].toString(),
                                runTime: (parseInt(time[1], 10) - parseInt(time[0], 10)) / 1000000000
                            });
                        }
                        result = {
                            id: id,
                            tests: tests
                        };
                        return [2 /*return*/, result];
                }
            });
        });
    };
    return Runner;
}());
exports["default"] = Runner;
